# Text Steganography
***

## Table of Contents
1. [General Info](#general-info)
2. [Technologies](#technologies)
3. [Example](#example)
4. [FAQs](#faqs)

## General Info
***
This project deals with hiding text message inside a casual text. 
Also called as Text Steganography. It is extremely useful technique
for conceling text messages. In this project there are two function namely:
* 'encode' <br>This method encodes the text also called as secret message inside a covering message. It generates a key which is saved in <i>key.txt</i> file after executing the method. This key.txt file is later used for decoding the message. 
* 'decode'<br> This method decodes the text from the covering message that is previously encoded by the encode function. This function uses the key.txt file generated from the encode method. 

## Technologies
***
A list of libraries used within the project:
* No additional modules are required for this package


## Example
***
Example to encode the text message in a covering message
```python

from TextStega import TextStega

key = TextStega().encode(CoverFilePath, EncodeFilePath)

# CoverFilePath(str) : "path of the txt file which contains the covering text" 
# EncodeFilePath(str) : "path of the txt file which contains the encoded message"

```

Example to decode the text from the covering message

```python

from TextStega import textStega

decoded_text = TextStega().decode(CoverFilePath, keyFilePath) 

# CoverFilePath(str) : path of the covering txt file.
# keyFilePath(str) : path of the key.txt file generated by the encode method

```


## FAQs
***
A list of frequenctly asked questions
1. **What is text steganography?**<br>
Steganography is the technique of hiding secret data within an ordinary, non-secret, file or message in order to avoid detection. More information can be found on this [Wikipedia](https://en.wikipedia.org/wiki/Steganography) page.

2. **Where can I use this package?**<br>
This tool is used to craftfully hide the data in plain texts. So this package can be used to hide secret text messages by encoding them in covering text messages to maintain the secrecy.

3. **How long should be my covering text?**<br>
The covering text should be sufficiently long to hide all the characters of the secret message. If not then the algorithm throws an exception. 





   





